<?php
/**
 * @package Stuvus Infoscreen Feed Builder
 * @version 0.0.1
 */
/*
Plugin Name: Stuvus Infoscreen Feed Builder
Version: 0.0.1
Description: Extends the rss feed in a form usable by the infoscreens
Author: Christoph Walcher
Author URI: https://wiomoc.de
*/

function st_image_rss_item() {
  if (has_post_thumbnail()) {
  	printf('<enclosure url="%s" type="image" />', get_the_post_thumbnail_url($post->ID, 'full'));
  } 
}

function st_highlights_rss_head() {
  if (empty($_GET["infoscreen"])) return $excerpt;

  $posts = get_posts(array(
    'post_type' => 'attachment',
    'numberposts' => 8,
    'search_columns' => array('post_content'),
    's' => $_GET["infoscreen"]
  ));


  foreach ($posts as $post) {
?>
<item>
		<title><?php echo get_the_title_rss($post); ?></title>
		<link><?php the_permalink($post); ?></link>
		<pubDate><?php echo current_time( 'D, d M Y H:i:s +0000'); ?></pubDate>
		<guid isPermaLink="false"><?php the_guid($post); ?></guid>
		<description><![CDATA[<?php echo wp_get_attachment_caption($post->ID); ?>]]></description>
		<enclosure url="<?php echo wp_get_attachment_image_url($post->ID, 'full'); ?>" type="image" />
</item>
<?php
  }
}

/* based on  https://github.com/WordPress/wordpress-develop/blob/b6d285fbe99d9c86c315f765204aa1474db8bf62/src/wp-includes/formatting.php#L3949 */
function st_excerpt_rss($excerpt) {
  if (empty($_GET["infoscreen"])) return $excerpt;


  $post = get_post();
  if (!empty($post) && !empty($post->post_excerpt)) return $post->post_excerpt;

  $text = get_the_content( '', false );
  $text = strip_shortcodes( $text );
  $text = excerpt_remove_blocks( $text );
  $text = excerpt_remove_footnotes( $text );

  /*
   * Temporarily unhook wp_filter_content_tags() since any tags
   * within the excerpt are stripped out. Modifying the tags here
   * is wasteful and can lead to bugs in the image counting logic.
   */
  $filter_image_removed = remove_filter( 'the_content', 'wp_filter_content_tags', 12 );

  /*
   * Temporarily unhook do_blocks() since excerpt_remove_blocks( $text )
   * handles block rendering needed for excerpt.
   */
  $filter_block_removed = remove_filter( 'the_content', 'do_blocks', 9 );

  /** This filter is documented in wp-includes/post-template.php */
  $text = apply_filters( 'the_content', $text );
  $text = str_replace( ']]>', ']]&gt;', $text );

  // Restore the original filters if removed.
  if ( $filter_block_removed ) {
    add_filter( 'the_content', 'do_blocks', 9 );
  }

  if ( $filter_image_removed ) {
    add_filter( 'the_content', 'wp_filter_content_tags', 12 );
  }

  $excerpt_length = 70;
  $text = wp_trim_words( $text, $excerpt_length, '' );
  

  $last_punctuation_pos = strrpos($text, '.');
  $last_alt_punctuation_pos = strrpos($text, '!');
  
  if($last_punctuation_pos != false) {
    if($last_alt_punctuation_pos != false && $last_alt_punctuation_pos > $last_punctuation_pos) {
      $last_punctuation_pos = $last_alt_punctuation_pos;
    }
  } else {
    $last_punctuation_pos = $last_alt_punctuation_pos;
  }

  if($last_punctuation_pos != false) {
      $text = substr($text, 0, $last_punctuation_pos + 1);
  }

  return $text;
}


add_action( 'rss2_item', 'st_image_rss_item' );
add_action( 'rss2_head', 'st_highlights_rss_head' );
add_filter( 'the_excerpt_rss', 'st_excerpt_rss' );